Codeforces Round #552 (Div. 3) A B C D

2024-03-06 14:50
文章标签 codeforces round div 552

本文主要是介绍Codeforces Round #552 (Div. 3) A B C D,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

A.
题意:一行给出4个数,分别代表a+b, a+c, b+c, a+b+c。让你输出a, b, c(print a, b and c in any order)
思路:默认sort从小到大排个序, 然后让第4个和第1,2,3个相减输出即可。

#include <bits/stdc++.h>using namespace std;#define INF 0x3f3f3f3f
typedef long long int ll;int n;int main() {ios::sync_with_stdio(false);vector<int> a(4);for (int i = 0; i < 4; i++) {cin >> a[i];}sort(a.begin(), a.end());cout << a[3] - a[0] << " " << a[3] - a[1] << " " << a[3] - a[2] << endl;return 0;
}

B.
题意:第一行输入一个数n,第二行输入n个数,提供了三个操作(有一个常量D):
1.a[i] = a[i] + D
2.a[i] = a[i] - D
3.a[i]不变
问这个array里面的数能不能通过这三个操作来使所有数都相同。
思路:可以用vector中的查重去重功能。
1.若只有一个不同的数,直接输出0。
2.若有两个不同的数(设 a>b)
1.a与b的中点为整数(e.i (b-a)%2 == 0)
输出(b-a)/2
2.a与b的中点为浮点数(e.i (b-a)%2 == 1)
输出 b-a
3.若有三个不同的数(设 a > b > c),只有当a-b == b-c,可以变为所需数列,D == a-b == a-c。
4.若有三个以上的不同的数,则永远不能变为所有数都相同的数列,输出-1。
经验:vector的查重去重功能。


#include <bits/stdc++.h>using namespace std;#define INF 0x3f3f3f3f
typedef long long int ll;int n;int main() {ios::sync_with_stdio(false);cin >> n;vector<int> a(n);for (int i = 0; i < n; i++) {cin >> a[i];}//vector查重去重sort(a.begin(), a.end());a.resize(unique(a.begin(), a.end()) - a.begin());///*也可以这么写sort(a.begin(), a.end());vector<int>::iterator it;vector<int>::iterator tempend = a.end();it = unique(a.begin(), a.end());a.erase(it, tempend);*/if(a.size() > 3) {cout << -1 << endl;return 0;}else if(a.size() == 3) {if(a[2] - a[1] == a[1] - a[0]) {cout << a[2] - a[1] << endl;return 0;}else {cout << -1 << endl;return 0;}}else if(a.size() == 2) {if((a[1] - a[0]) % 2) {cout << a[1] - a[0] << endl;return 0;}else {cout << (a[1] - a[0])/2 << endl;return 0;}}else if(a.size() == 1) {cout << 0 << endl;return 0;}return 0;
}

C.
题意:有个猫在周1,3,7吃鱼,26吃兔子,4,5吃鸡(营养搭配真好),然后给你三个数代表鱼,兔子,鸡的数量,问你这些数量的食物可以撑多少天(连续的天)。
官方题解:在这里插入图片描述

#include <bits/stdc++.h>using namespace std;#define INF 0x3f3f3f3f
typedef long long int ll;int full, ans;
vector<int> a(3);int main() {ios::sync_with_stdio(false);cin >> a[0] >> a[1] >> a[2];int full = min({a[0]/3, a[1]/2, a[2]/2});a[0] -= 3 * full;a[1] -= 2 * full;a[2] -= 2 * full;vector<int> idx({0, 1, 2, 0, 2, 1, 0});for (int i = 0; i < 7; i++) {vector<int> b = a;int cur = 0;int day = i;while(b[idx[day]] > 0) {b[idx[day]]--;cur++;day = (day + 1) % 7; //让day在 0~7 内循环}ans = max(ans, full * 7 + cur);}cout << ans << endl;return 0;
}

D.
题意 :两种类型的robot 做一定数量的操作 要让他们走的路程最远
思路:
1.若遇到有光的区域,肯定是优先选择battery的,这样可以让accumulator的充电,这样消耗的电和充的电正好抵消。
2.若遇到无光的区域, 肯定优先选择accumulator的,让他电耗耗光么正好可以充电。
3.WA两发的原因:若遇到有光的区域 并且accumulator的电正好是满的,也就是充不进电,那这时就不能选battery的,而要选accumulator的了。可以参照要通过路径是1(此时充满电) 1 1这种情况。

下面附上ac代码:

#include <bits/stdc++.h>using namespace std;int arr[300000], n, sum = 0, a, b;int main() {ios::sync_with_stdio(false);cin >> n >> a >> b;int tempa = a;int tempb = b;for (int i = 1; i <= n; i++) {cin >> arr[i];}for (int i = 1; i <= n; i++) {if (arr[i]) {if(tempb < b) {if(tempa) {tempa--;tempb++;}else if(tempb){tempb--;}}else {tempb--;}sum++;if (tempa == 0 && tempb == 0) {cout << sum << endl;return 0;}}else {if(tempb) {tempb--;}else if(tempa) {tempa--;}sum++;if (tempa == 0 && tempb == 0) {cout << sum << endl;return 0;}}}cout << n << endl; //全都能走完return 0;
}

这篇关于Codeforces Round #552 (Div. 3) A B C D的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/780407

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

半年高达552亿元,锁定云第一,中国电信天翼云紧追不舍

【科技明说 | 科技热点关注】 刚才我注意到中国电信公布2024年中期业绩,报告期内,中国电信实现营业收入为人民币2660亿元,同比增长2.8%,其中服务收入为人民币2462亿元,同比增长4.3%;净利润为人民币218亿元,同比增长8.2%。 其中亮点,2024年上半年,天翼云保持快速增长,收入达到了552亿元,同比增长20.4%,占服务收入比升至22.4%,市场头部地位进一步巩固。 为

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s